/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /root/1813/mozilla/netwerk/cookie/public/nsICookie.idl
 */

package org.mozilla.interfaces;

public interface nsICookie extends nsISupports {

  String NS_ICOOKIE_IID =
    "{e9fcb9a4-d376-458f-b720-e65e7df593bc}";

  /**
     * the name of the cookie
     */
  String getName();

  /**
     * the cookie value
     */
  String getValue();

  /**
     * true if the cookie is a domain cookie, false otherwise
     */
  boolean getIsDomain();

  /**
     * the host (possibly fully qualified) of the cookie
     */
  String getHost();

  /**
     * the path pertaining to the cookie
     */
  String getPath();

  /**
     * true if the cookie was transmitted over ssl, false otherwise
     */
  boolean getIsSecure();

  /**
     * expiration time (local timezone) expressed as number of seconds since Jan 1, 1970
     */
  double getExpires();

  /**
     * P3P status of cookie.  Values are
     *
     *   STATUS_UNKNOWN -- cookie collected in a previous session and this info no longer available
     *   STATUS_ACCEPTED -- cookie was accepted as it
     *   STATUS_DOWNGRADED -- cookie was accepted but downgraded to a session cookie
     *   STATUS_FLAGGED -- cookie was accepted with a warning being issued to the user
     *   STATUS_REJECTED -- cookie was not accepted
     */
  int STATUS_UNKNOWN = 0;

  int STATUS_ACCEPTED = 1;

  int STATUS_DOWNGRADED = 2;

  int STATUS_FLAGGED = 3;

  int STATUS_REJECTED = 4;

  int getStatus();

  /**
     * Site's compact policy.  Values are
     *
     *   POLICY_UNKNOWN -- cookie collected in a previous session and this info no longer available
     *   POLICY_NONE -- site did not send a compact policy along with the cookie
     *   POLICY_NO_CONSENT -- site collects identfiable information without user involvement
     *   POLICY_IMPLICIT_CONSENT -- site collects identifiable information unless user opts out
     *   POLICY_EXPLICIT_CONSENT -- site does not collect identifiable information unless user opts in
     *   POLICY_NO_II -- site does not collect identifiable information
     */
  int POLICY_UNKNOWN = 0;

  int POLICY_NONE = 1;

  int POLICY_NO_CONSENT = 2;

  int POLICY_IMPLICIT_CONSENT = 3;

  int POLICY_EXPLICIT_CONSENT = 4;

  int POLICY_NO_II = 5;

  int getPolicy();

}